import edu.princeton.cs.algs4.StdOut;

public class Example1 {
    
    // define class ImmutablePair<A, B> with fields 'first' and 'second'

    public static class ImmutablePair<TypeA, TypeB> {

        public final TypeA first;
        public final TypeB second;

        public ImmutablePair(TypeA first, TypeB second) {
            this.first = first;
            this.second = second;
        }

        public String toString() {
            return "pair(first='" + this.first +
                "', second='" + this.second + "')";
        }
        
    }
    
    public static void main(String[] args) {
        ImmutablePair<String, String> p1 = new ImmutablePair<>("hello",
                                                               "world");
        ImmutablePair<String, Integer> p2 = new ImmutablePair<>("james",
                                                                22);

        StdOut.println(p1);
        StdOut.println(p2);
    }
    
}
